"{ Package: 'jv:libgdbs' }"

Object subclass:#GDBPTY
	instanceVariableNames:'name master slave'
	classVariableNames:''
	poolDictionaries:''
	category:'GDB-Private'
!

!GDBPTY class methodsFor:'instance creation'!

new
    "return an initialized instance"

    ^ self basicNew initialize.
! !

!GDBPTY methodsFor:'accessing'!

master
    ^ master
!

name
    ^ name
!

slave
    ^ slave
! !

!GDBPTY methodsFor:'initialization & release'!

initialize
    | triplet |


    OperatingSystem isUNIXlike ifTrue:[ 
        "Use a pseudo-tty"
        triplet := OperatingSystem makePTY.

        name := triplet at:3.

        "/ pty at:1 is the master;
        "/ pty at:2 is the slave
        master := NonPositionableExternalStream forReadWriteToFileDescriptor:(triplet at:1).
        master buffered:false.

        slave := NonPositionableExternalStream forReadWriteToFileDescriptor:(triplet at:2).
        master buffered:false.

    ] ifFalse:[ 
        OperatingSystem isMSWINDOWSNTlike ifTrue:[ 
            self error: 'Windows are not (yet) supported'
        ] ifFalse:[ 
            self error: 'Operating system not supported'
        ]
    ].

    "Modified: / 09-06-2014 / 18:23:21 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

release
    name := nil.
    master notNil ifTrue:[ 
        master close.
        master := nil.
    ].
    slave notNil ifTrue:[ 
        slave close.
        slave := nil.
    ].

    "Created: / 09-06-2014 / 18:25:52 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

